<script setup lang="ts">
import AForm from '@/components/AForm/index.vue'
import { FormConfigType } from '@/components/AForm/type'
import { ToolbarConfigType } from '@/components/AToolbar/type'
import { ColumnConfigType } from '@/components/ATable/type'
import { StrAnyObj, StrAnyObjArr } from '@/typings'
import { useHandleData } from '@/utils/useHandleData'
import { getPageApi, getDetailApi, addApi, editApi, deleteApi } from '@/api/business/contract/detail'

const queryRef = ref<InstanceType<typeof AForm>>()
const formRef = ref<InstanceType<typeof AForm>>()

const showQuery = ref<boolean>(true)
const selectKeys = ref<string[]>([])
const pageTotal = ref<number>(0)

const queryData = ref<StrAnyObj>({ pageNum: 1, pageSize: 10 })
const tableData = ref<StrAnyObjArr>([])
const formData = ref<StrAnyObj>({})

const dialogTitle = ref<string>('')
const dialogVisible = ref<boolean>(false)

const queryConfig: FormConfigType[] = [
  {
    type: 'input',
    prop: 'productName',
    label: '产品名称'
  },
  {
    type: 'input',
    prop: 'productCode',
    label: '产品货号'
  },
  {
    type: 'input',
    prop: 'productSpec',
    label: '产品规格'
  },
  {
    type: 'input',
    prop: 'productColour',
    label: '颜色'
  },
  {
    type: 'input',
    prop: 'productUnit',
    label: '单位'
  },
  {
    type: 'input',
    prop: 'quantity',
    label: '数量'
  },
  {
    type: 'input',
    prop: 'unitPrice',
    label: '单价'
  },
  {
    type: 'input',
    prop: 'remark',
    label: '备注'
  },
  {
    type: 'input',
    prop: 'createUser',
    label: '创建人'
  },
  {
    type: 'input',
    prop: 'createTime',
    label: '创建时间'
  },
  {
    type: 'input',
    prop: 'updateUser',
    label: '更新人'
  },
  {
    type: 'input',
    prop: 'updateTime',
    label: '更新时间'
  },
  {
    type: 'input',
    prop: 'delFlag',
    label: '逻辑删除标记'
  },
]

const toolbarConfig: ToolbarConfigType[] = [
  {
    common: 'search',
    click() {
      queryData.value.pageNum = 1
      getPage()
    }
  },
  {
    common: 'reset',
    click() {
      queryRef.value?.resetFields()
      getPage()
    }
  },
  {
    common: 'add',
    click() {
      dialogVisible.value = true
      dialogTitle.value = '新增'
    }
  },
  {
    common: 'delete',
    disabled() {
      return selectKeys.value.length == 0
    },
    click() {
      handleRemove(selectKeys.value)
    }
  }
]

const columnConfig: ColumnConfigType[] = [
  {
    prop: 'productName',
    label: '产品名称'
  },
  {
    prop: 'productCode',
    label: '产品货号'
  },
  {
    prop: 'productSpec',
    label: '产品规格'
  },
  {
    prop: 'productColour',
    label: '颜色'
  },
  {
    prop: 'productUnit',
    label: '单位'
  },
  {
    prop: 'quantity',
    label: '数量'
  },
  {
    prop: 'unitPrice',
    label: '单价'
  },
  {
    prop: 'remark',
    label: '备注'
  },
  {
    prop: 'createUser',
    label: '创建人'
  },
  {
    prop: 'createTime',
    label: '创建时间'
  },
  {
    prop: 'updateUser',
    label: '更新人'
  },
  {
    prop: 'updateTime',
    label: '更新时间'
  },
  {
    prop: 'delFlag',
    label: '逻辑删除标记'
  },
  {
    width: 250,
    handleConfig: [
      {
        common: 'update',
        click(row) {
          dialogVisible.value = true
          dialogTitle.value = '编辑'
          getDetailApi({ id: row.id }).then((resp: StrAnyObj) => {
            formData.value = resp
          })
        }
      },
      {
        common: 'delete',
        click(row) {
          handleRemove([row.id])
        }
      }
    ]
  }
]

const formConfig: FormConfigType[] = [
  {
    type: 'input',
    prop: 'productName',
    label: '产品名称',
    rule: [{ required: true, message: '产品名称不能为空', trigger: 'blur' }]
  },
  {
    type: 'input',
    prop: 'productCode',
    label: '产品货号',
    rule: [{ required: true, message: '产品货号不能为空', trigger: 'blur' }]
  },
  {
    type: 'input',
    prop: 'productSpec',
    label: '产品规格',
    rule: [{ required: true, message: '产品规格不能为空', trigger: 'blur' }]
  },
  {
    type: 'input',
    prop: 'productColour',
    label: '颜色',
    rule: [{ required: true, message: '颜色不能为空', trigger: 'blur' }]
  },
  {
    type: 'input',
    prop: 'productUnit',
    label: '单位',
    rule: [{ required: true, message: '单位不能为空', trigger: 'blur' }]
  },
  {
    type: 'input',
    prop: 'quantity',
    label: '数量',
    rule: [{ required: true, message: '数量不能为空', trigger: 'blur' }]
  },
  {
    type: 'input',
    prop: 'unitPrice',
    label: '单价',
    rule: [{ required: true, message: '单价不能为空', trigger: 'blur' }]
  },
  {
    type: 'input',
    prop: 'remark',
    label: '备注',
    rule: [{ required: true, message: '备注不能为空', trigger: 'blur' }]
  },
  {
    type: 'input',
    prop: 'createUser',
    label: '创建人',
    rule: [{ required: true, message: '创建人不能为空', trigger: 'blur' }]
  },
  {
    type: 'input',
    prop: 'createTime',
    label: '创建时间',
    rule: [{ required: true, message: '创建时间不能为空', trigger: 'blur' }]
  },
  {
    type: 'input',
    prop: 'updateUser',
    label: '更新人',
    rule: [{ required: true, message: '更新人不能为空', trigger: 'blur' }]
  },
  {
    type: 'input',
    prop: 'updateTime',
    label: '更新时间',
    rule: [{ required: true, message: '更新时间不能为空', trigger: 'blur' }]
  },
  {
    type: 'input',
    prop: 'delFlag',
    label: '逻辑删除标记',
    rule: [{ required: true, message: '逻辑删除标记不能为空', trigger: 'blur' }]
  },
]

onMounted(() => {
  getPage()
})

function getPage() {
  getPageApi(queryData.value).then((resp) => {
    tableData.value = resp.records
    pageTotal.value = resp.total
  })
}

function tableSelectionChange(item: StrAnyObjArr) {
  selectKeys.value = item.map((item) => item.id)
}

function formSubmit() {
  formRef.value?.validate(() => {
    if (formData.value.id) {
      editApi(formData.value).then(() => {
        dialogVisible.value = false
        ElMessage.success('修改成功')
        getPage()
      })
    } else {
      addApi(formData.value).then(() => {
        dialogVisible.value = false
        ElMessage.success('新增成功')
        getPage()
      })
    }
  })
}

function formClosed() {
  formRef.value?.resetFields()
}

function handleRemove(idList: string[]) {
  useHandleData('是否确认删除？', () => {
    deleteApi({ idList }).then(() => {
      ElMessage.success('删除成功')
      getPage()
    })
  })
}
</script>

<template>
  <div>
    <el-card v-if="showQuery">
      <a-form ref="queryRef" v-model="queryData" :config="queryConfig" :span="6"> </a-form>
    </el-card>

    <a-table
      selection
      :data="tableData"
      :page-total="pageTotal"
      :toolbar-config="toolbarConfig"
      :column-config="columnConfig"
      v-model:showQuery="showQuery"
      v-model:page-num="queryData.pageNum"
      v-model:page-size="queryData.pageSize"
      @page-num-change="getPage"
      @page-size-change="getPage"
      @selection-change="tableSelectionChange"
    >
    </a-table>

    <a-dialog
      v-model="dialogVisible"
      :title="dialogTitle"
      @submit="formSubmit"
      @closed="formClosed"
    >
      <a-form ref="formRef" v-model="formData" :config="formConfig" :span="24"> </a-form>
    </a-dialog>
  </div>
</template>
